# coding: utf-8

"""
    Rapidata.Dataset

    No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

    The version of the OpenAPI document: v1
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from rapidata.api_client.models.file_asset import FileAsset
from rapidata.api_client.models.null_asset import NullAsset
from rapidata.api_client.models.text_asset import TextAsset
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

DATAPOINTASSET_ONE_OF_SCHEMAS = ["FileAsset", "MultiAsset", "NullAsset", "TextAsset"]

class DatapointAsset(BaseModel):
    """
    DatapointAsset
    """
    # data type: FileAsset
    oneof_schema_1_validator: Optional[FileAsset] = None
    # data type: MultiAsset
    oneof_schema_2_validator: Optional[MultiAsset] = None
    # data type: NullAsset
    oneof_schema_3_validator: Optional[NullAsset] = None
    # data type: TextAsset
    oneof_schema_4_validator: Optional[TextAsset] = None
    actual_instance: Optional[Union[FileAsset, MultiAsset, NullAsset, TextAsset]] = None
    one_of_schemas: Set[str] = { "FileAsset", "MultiAsset", "NullAsset", "TextAsset" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    discriminator_value_class_map: Dict[str, str] = {
    }

    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = DatapointAsset.model_construct()
        error_messages = []
        match = 0
        # validate data type: FileAsset
        if not isinstance(v, FileAsset):
            error_messages.append(f"Error! Input type `{type(v)}` is not `FileAsset`")
        else:
            match += 1
        # validate data type: MultiAsset
        if not isinstance(v, MultiAsset):
            error_messages.append(f"Error! Input type `{type(v)}` is not `MultiAsset`")
        else:
            match += 1
        # validate data type: NullAsset
        if not isinstance(v, NullAsset):
            error_messages.append(f"Error! Input type `{type(v)}` is not `NullAsset`")
        else:
            match += 1
        # validate data type: TextAsset
        if not isinstance(v, TextAsset):
            error_messages.append(f"Error! Input type `{type(v)}` is not `TextAsset`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in DatapointAsset with oneOf schemas: FileAsset, MultiAsset, NullAsset, TextAsset. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in DatapointAsset with oneOf schemas: FileAsset, MultiAsset, NullAsset, TextAsset. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into FileAsset
        try:
            instance.actual_instance = FileAsset.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into MultiAsset
        try:
            instance.actual_instance = MultiAsset.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into NullAsset
        try:
            instance.actual_instance = NullAsset.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into TextAsset
        try:
            instance.actual_instance = TextAsset.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into DatapointAsset with oneOf schemas: FileAsset, MultiAsset, NullAsset, TextAsset. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into DatapointAsset with oneOf schemas: FileAsset, MultiAsset, NullAsset, TextAsset. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], FileAsset, MultiAsset, NullAsset, TextAsset]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())

from rapidata.api_client.models.multi_asset import MultiAsset
# TODO: Rewrite to not use raise_errors
DatapointAsset.model_rebuild(raise_errors=False)

